/*
 * Copyright (c) 1999, Jesper Hansen. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither name of the company nor the names of its contributors may
 *    be used to endorse or promote products derived from this software
 *    without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE REGENTS OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 * LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 * NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

//-----------------------------------------------------------------------------
#ifndef DAMN_DLE_INTERNAL_H
#define DAMN_DLE_INTERNAL_H
//-----------------------------------------------------------------------------
//-------------------------------------
#include <interface/Rect.h>
//-------------------------------------
#include "Core.h"
//-----------------------------------------------------------------------------

//	printf( "Adjust1:" ); rect.PrintToStream();
//	printf( "Forced :" ); ci->object->GetForcedSize().PrintToStream();
//	rect = ci->object->ForcedClip( rect );
//	printf( "Adjust2:" ); rect.PrintToStream();

#define FORCESIZE( ci, rect ) \
	rect = ci->object->ForcedClip( rect );

#define ADDBORDERSPACE( ci, rect ) \
	if( !ci->objectisgroup ) \
	{ \
		float horzinner = ci->object->GetInnerLeft() + ci->object->GetInnerRight(); \
		float vertinner = ci->object->GetInnerTop() + ci->object->GetInnerBottom(); \
		rect.horz.min += horzinner; \
 		rect.horz.max += horzinner; \
		rect.vert.min += vertinner; \
		rect.vert.max += vertinner; \
	}

#define REMOVEBORDERSPACE( ci, rect ) \
	if( !ci->objectisgroup ) \
	{ \
		rect.left += ci->object->GetInnerLeft(); \
		rect.right -= ci->object->GetInnerRight(); \
		rect.top += ci->object->GetInnerTop(); \
		rect.bottom -= ci->object->GetInnerBottom(); \
	}

#define ADJUSTRECT( ci, rect ) \
	FORCESIZE( ci, rect ); \
	ADDBORDERSPACE( ci, rect );

#define DEADJUSTRECT( vi, rect ) \
	REMOVEBORDERSPACE( vi, rect );

namespace dle
{
	template<class T> T min( T a, T b ) { return a<b?a:b; }
	template<class T> T max( T a, T b ) { return a>b?a:b; }

	class DefaultSettings : public Settings
	{
	public:
		DefaultSettings();

		const Settings *GetParentSettings() const;
	};
}

//-----------------------------------------------------------------------------
#endif

